/*$Id: c_sim.cc,v 26.15 2007/02/18 09:52:30 al Exp $ -*- C++ -*-
 * Copyright (C) 2001 Albert Davis
 * Author: Albert Davis <aldavis@ieee.org>
 *
 * This file is part of "Gnucap", the Gnu Circuit Analysis Package
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 *------------------------------------------------------------------
 * command interface functions associated with the SIM base class
 */
//testing=script 2006.07.17
#include "s_ac.h"
#include "s_dc.h"
#include "s_tr.h"
#include "s_fo.h"
#include "c_comand.h"
#include "l_dispatcher.h"
extern DISPATCHER<CMD> command_dispatcher;
/*--------------------------------------------------------------------------*/
namespace {
/*--------------------------------------------------------------------------*/
class CMD_AC : public CMD {
public:
  void operator()(CS& cmd)const
  {
    static AC ac;
    ac.command(cmd);
  }
} p1;
DISPATCHER<CMD>::INSTALL d1(&command_dispatcher, "ac", &p1);
/*--------------------------------------------------------------------------*/
class CMD_DC : public CMD {
public:
  void operator()(CS& cmd)const
  {
    static DC dc;
    dc.command(cmd);
  }
} p2;
DISPATCHER<CMD>::INSTALL d2(&command_dispatcher, "dc", &p2);
/*--------------------------------------------------------------------------*/
class CMD_FOURIER : public CMD {
public:
  void operator()(CS& cmd)const
  {
    static FOURIER fo;
    fo.command(cmd);
  }
} p3;
DISPATCHER<CMD>::INSTALL d3(&command_dispatcher, "fourier", &p3);
/*--------------------------------------------------------------------------*/
class CMD_OP : public CMD {
public:
  void operator()(CS& cmd)const
  {
    static OP op;
    op.command(cmd);
  }
} p4;
DISPATCHER<CMD>::INSTALL d4(&command_dispatcher, "op", &p4);
/*--------------------------------------------------------------------------*/
class CMD_TRAN : public CMD {
public:
  void operator()(CS& cmd)const
  {
    static TRANSIENT tr;
    tr.command(cmd);
  }
} p5;
DISPATCHER<CMD>::INSTALL d5(&command_dispatcher, "transient", &p5);
/*--------------------------------------------------------------------------*/
class CMD_MARK : public CMD {
public:
  void operator()(CS&)const
  {untested();
    SIM::freezetime = true;
  }
} p6;
DISPATCHER<CMD>::INSTALL d6(&command_dispatcher, "mark", &p6);
/*--------------------------------------------------------------------------*/
class CMD_UNMARK : public CMD {
public:
  void operator()(CS&)const
  {
    SIM::freezetime = false;
  }
} p7;
DISPATCHER<CMD>::INSTALL d7(&command_dispatcher, "unmark", &p7);
/*--------------------------------------------------------------------------*/
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
